



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>libgdx, mouse 关节</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">libgdx, mouse 关节</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 14:27:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>鼠标与body的交互就靠这个mouse 关节了。</p>
<p>在使用中：主要分成3步：</p>
<p>步1：mouseDown : 这个时期，调用world-&gt;QueryAABB。它有一个回调接口，并依据鼠标指针指定一个AABB的极小区域。</p>
<p>有3个细节需注意：</p>
<p>细节1：鼠标的xy&#20540;是屏幕坐标系统的，要转换成stage坐标系统（stage-&gt;screenToStageCoordinates)，然后再转成box2d的单位xy&#20540;；</p>
<p>细节2：AABB极小区域是多小？当然是越小越好（比方：0.001f ，单位是米的，或者1个像素的差）x-0.001f, y-0.001f, x&#043;0.001f,y&#043;0.001f。这样就形成了一个极小区域。但实际測试时发现，回调函数被调用时，鼠标距离我们的目标body还有3-5个像素，这可能会造成视觉上的困惑。为解决问题，我一般在回调函数中再对其进行“（鼠标）点的測试”，即fixture-&gt;testPoint(x,y)方法。用它来实现測试我们的fixture是否被击中，以严&#26684;的击中測试来定位fixture击中与否，以此来建立鼠标关节会更符合视觉习惯。</p>
<p>细节3：bodyB是操作目标，bodyA通常是静态body；我第一次使用时将这两个搞混了，结果发生崩溃异常。（參见后面的图1）</p>
<p>步2：mouseDrag：在这个时间，仅仅是简单设置目标位置即可。注意坐标的转换与单位的转换。</p>
<p>步3：mouseUp：这个时间是销毁鼠标关节。一般要注意将关节对象的引用置空（=null)。</p>
<p>最后还要依据实例的body属性，特别调节例如以下參数，以保证mouse关节行为不是那么怪异！</p>
<p>mouseJointDef.dampingRatio = 1;<br /><br />
mouseJointDef.frequencyHz = 60; 、、调大些，会使用命中时显的更灵敏。<br /><br />
mouseJointDef.maxForce = 5000;、、力要足够大，否则可能由于干只是重力而出现不期望的效果，比方“向下掉”。</p>
<p>mouseJointDef.collideConnected = true;、、一般都设置为true，连接的body也要有碰撞，默认&#20540;为false，假设为false，它可能会“向下掉，且掉到地板以下去了”。</p>
<p>下图是图1：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140501133107921"></p>
<p>代码參考：</p>
<p>@Override<br /><br />
&nbsp; &nbsp; public boolean reportFixture(Fixture fixture) {<br /><br />
<br /><br />
<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; // 假设不是这个类型，直接转换会抛异常<br /><br />
// &nbsp; &nbsp; &nbsp; &nbsp;KwLetter kwLetter = (KwLetter)fixture.getBody().getUserData();<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; // 改动成例如以下代码<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; Object object = fixture.getBody().getUserData();<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; if (object instanceof KwLetter) {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; KwLetter kwLetter = (KwLetter)object;<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if (null == m_mouseJoint &amp;&amp; kwLetter.hit(m_mouseX2d, m_mouseY2d)) {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; Gdx.app.debug(&quot;reportFixture&quot;, &quot;kwLetter=&quot;&#043;kwLetter);<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; MouseJointDef mouseJointDef = new MouseJointDef();<br /><br />
// &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mouseJointDef.dampingRatio = 1;<br /><br />
// &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mouseJointDef.frequencyHz = 1;<br /><br />
// &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mouseJointDef.maxForce = 5;<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; mouseJointDef.target.set(new Vector2(m_mouseX2d, m_mouseY2d));<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; mouseJointDef.bodyA = m_kwGround.getBody();<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; mouseJointDef.bodyB = kwLetter.getBody();//目标<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; m_mouseJoint = (MouseJoint)m_world.createJoint(mouseJointDef);<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
<br /><br />
<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; return false;<br /><br />
&nbsp; &nbsp; }</p>
<p>public boolean hit(float x2d, float y2d)<br /><br />
&nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; return m_fixture.testPoint(x2d, y2d);<br /><br />
&nbsp; &nbsp; }</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r930kz93.html">Atitit&period;软件架构高扩展性and兼容性原理与概论实践attilax总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r45v78.html">浅谈Android中Activity的生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zkmlq.html">PHP连接SQLServer</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjj1ry9.html">wScratchPad 实现刮刮卡效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjmgn79.html">ExtJs布局之BOX</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ykd2nq.html">Eclipse改变外观，护眼模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj222d9.html">&lpar;3&rpar;java棧</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjvymk8.html">WebView Android 调用js且须要获取返回结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mel6epq.html">PHP导入导出Excel方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z7w5n9.html">201521123116  《java程序设计》第十周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxdkzq.html">SSH2&mdash;&mdash;filter过滤器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z10pg9.html">Redis之（七）主从同步与集群管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjzpy38.html">nginx常用配置系列-反向代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz33v08.html">I2C&lpar;三&rpar; linux3&period;4&lpar;内核分析&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j102xw9.html">linux为什么要使用CentOS开发？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwe21x9.html">day02python基本数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyoopd9.html">S表示1，L表示2，计算由S和L组成的序列之和为N的组合</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkggj38.html">Coursera-AndrewNg&lpar;吴恩达&rpar;机器学习笔记&mdash;&mdash;第三周编程作业（逻辑回归）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk44gv8.html">JS计算时间差值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kok7ljq.html">Javascript能做什么 不能做什么。</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnjmvz28.html">eclipse修改java代码后报错： java&period;lang&period;OutOfMemoryError&colon; PermGen space</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp0jx69.html">基本属性 - iOS中的本地通知</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zgpp09.html">list&comma; tuple&comma; dict&comma; set的用法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv15z7zq.html">Kqueue与epoll机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zxnr19.html">VJGUI消息设计－兼谈MFC、QT和信号&sol;槽机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge1ze78.html">史上最全然oophper  php文件上传之文件类型相应表，ie，火狐各一份。</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zg70j9.html">android -- 蓝牙 bluetooth （一） 入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyerom9.html">linq中的group by</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zxjzk9.html">linux嵌入式： 实现自己的tree命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdnvx79.html">C&num;学习之在辅助线程中修改UI控件----invoke方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
